/*
 *	string.c: part of xd(heXadecimal Dump tool)
 *	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
 */

#define	S	1
#define	M	2

static unsigned char char_lead[256] = {
/*0x00*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x10*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x20*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0x30*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0x40*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0x50*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0x60*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0x70*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 0, 
#if	defined(SJIS)
/*0x80*/	0, M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 
/*0x90*/	M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 
/*0xa0*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0xb0*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0xc0*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0xd0*/	S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S, 
/*0xe0*/	M, M, M, M, M, M, M, M, M, M, M, 0, 0, 0, 0, 0, 
/*0xf0*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
#elif	defined(EUC)
/*0x80*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x90*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xa0*/	0, M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 
/*0xb0*/	M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 
/*0xc0*/	M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 
/*0xd0*/	M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 
/*0xe0*/	M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 
/*0xf0*/	M, M, M, M, M, M, M, M, M, M, M, M, M, M, M, 0, 
#else
/*0x80*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x90*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xa0*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xb0*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xc0*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xd0*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xe0*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xf0*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
#endif
};

#if	!defined(SJIS) && !defined(EUC)
#ifdef	MBCHECK_TRAIL
#undef	MBCHECK_TRAIL
#endif
#endif

#ifdef	MBCHECK_TRAIL
#if	defined(SJIS)
static unsigned char char_trail[256] = {
/*0x00*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x10*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x20*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x30*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x40*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0x50*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0x60*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0x70*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 
/*0x80*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0x90*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xa0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xb0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xc0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xd0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xe0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xf0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0
};
#elif	defined(EUC)
static unsigned char char_trail[256] = {
/*0x00*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x10*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x20*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x30*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x40*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x50*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x60*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x70*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x80*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0x90*/	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
/*0xa0*/	0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xb0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xc0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xd0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xe0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
/*0xf0*/	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0
};
#endif	/*EUC*/
#endif	/*MBCHECK_TRAIL*/


#ifndef	min
#define	min(a,b)	((a)<(b)?(a):(b))
#endif


unsigned char*	dump_string(unsigned char* dst, unsigned char* src, int rest)
{
	int	length;
	unsigned int	c;
	extern int string_length;
	extern int overrun_ok;
	extern int overrun_yes;

	/* o͂镶̒߂(length > 0) */
	length = min(rest, string_length);
	
	/* OI[o */
	if (overrun_yes) {
		--length;
		*dst++ = ' ';
		src++;
	}

	/* Ō̏̕o͂ł length == 0 */
	while (--length >= 0) {
		c = *src++;
		switch(char_lead[c]) {
		case 0:
			*dst++ = '.';
			break;
		case S:
			*dst++ = c;
			break;
#if	defined(SJIS) || defined(EUC)
		case M:
#ifdef	MBCHECK_TRAIL
			if (char_trail[*src]) {
				*dst++ = c;
				*dst++ = *src++;
				--length;
			}
			else {
				*dst++ = '.';
			}
#else	/*!MBCHECK_TRAIL*/
			*dst++ = c;
			*dst++ = *src++;
			--length;
#endif	/*MBCHECK_TRAIL*/
			break;
#endif	/*defined(SJIS) || defined(EUC)*/
		}
	}
	if (overrun_yes = ++length) {
		if (rest <= string_length && !overrun_ok) {
			*(--dst-1) = '.';
		}
	}
	*dst = '\0';
	return dst;
}


#ifdef	DEBUG
#include	<stdio.h>

int dump_length = 64;
int overrun_ok = 0;
int overrun_yes = 0;

static unsigned long address;
static char	xdtab[] = "0123456789abcdef";
static char	inpbuf[BUFSIZ+4];
static char	outbuf[128];

static size_t	filbuf(FILE* fp)
{
	int	c;
	size_t n;

	overrun_ok = 0;
	if ((n = fread(inpbuf, sizeof(char), BUFSIZ, fp)) == BUFSIZ) {
		if ((c = getc(fp)) != EOF) {
			inpbuf[BUFSIZ] = c;
			ungetc(c, fp);
			overrun_ok = 1;
		}
	}
	return n;
}


static void ds(FILE* fp)
{
	char* inp;
	char* ptr;
	size_t	n;
	extern char* b4toha(const char*, char*, unsigned long*);

	address = 0UL;
	while (n = filbuf(fp)) {
		inp = inpbuf;
		while ((int)n > 0) {
			ptr = b4toha(&xdtab[0], outbuf, &address);
			*ptr++ = ' ';
			ptr = dump_string(ptr, inp, n);
			*ptr++ = '\n';
			*ptr = '\0';
			fputs(outbuf, stdout);
			address += dump_length;
			inp += dump_length;
			n -= dump_length;
		}
	}
}


int	main(int ac, char** av)
{
	FILE* fp;

	if (ac == 1) {
		ds(stdin);
	}
	else {
		while (--ac > 0) {
			if (fp = fopen(*++av, "rb")) {
				ds(fp);
				fclose(fp);
			}
		}
	}
	return 0;
}
#endif
