/*
 *	xd.c: part of xd(heXadecimal Dump tool)
 *	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	<stdio.h>
#ifdef	HAVE_STDLIB_H
#include	<stdlib.h>
#endif
#ifdef	HAVE_UNISTD_H
#include	<unistd.h>
#endif
#include	<string.h>
#include	<limits.h>
#ifdef	HUMAN68K
#include	<doslib.h>
#endif
#include	"xd.h"
#include	"getopt.h"

#ifndef	OUTBUFSIZ
#define	OUTBUFSIZ	(BUFSIZ*4)
#endif	/*OUTBUFSIZ*/

#define	_m_strlen(str)	\
({\
	char* local_str = (str);\
	while (*local_str++);\
	(--local_str - (str));\
})


void print_copyright(void)
{
	fputs("xd-" VERSION "  Copyright 1994,95 oo\n", stderr);
}


/*
 *	option variables for GNU getopt()
 */
int		adr_out = 1;
int		buf_out = 1;
int		fil_out = 1;
int		str_out = 1;
#ifdef	HUMAN68K
int		chk_nul = 1;
int		out_bin = 1;
#endif
int		version = 0;
int		help = 0;
int		dump_order  = XD_ORDER_BIG;
int		dump_type   = XD_TYPE_CHAR;
int		dump_format = XD_FORMAT_HEX;
ul_t	dump_length = ULONG_MAX;		/* ̓t@C_vIʒu */
ul_t	dump_offset = 0L;				/* ̓t@C_vJnʒu */
ul_t	dump_bias   = 0L;
ul_t	dump_position = 0L;

struct option long_opt[] = {
	{"char",			no_argument,		NULL,		'1'},
	{"short",			no_argument,		NULL,		'2'},
	{"long",			no_argument,		NULL,		'4'},
	{"longlong",		no_argument,		NULL,		'8'},
	{"no-address",		no_argument,		NULL,		'A'},
	{"bias",			required_argument,	NULL,		'B'},
	{"no-dump",			no_argument,		NULL,		'D'},
	{"no-filename",		no_argument,		NULL,		'F'},
	{"length",			required_argument,	NULL,		'L'},
#ifdef	HUMAN68K
	{"no-check-null",	no_argument,		NULL,		'N'},
#endif
	{"offset",			required_argument,	NULL,		'O'},
	{"no-string",		no_argument,		NULL,		'S'},
	{"version",			no_argument,		NULL,		'V'},
	{"big-endian",		no_argument,		NULL,		'b'},
	{"dump-decimal"	,	no_argument,		NULL,		'd'},
	{"dump-float",		no_argument,		NULL,		'f'},
	{"help",			no_argument,		NULL,		'h'},
	{"little-endian",	no_argument,		NULL,		'l'},
#if	defined(HUMAN68K) || defined(MSDOS)
	{"text-output",		no_argument,		NULL,		't'},
#endif
	{"dump-unsigned",	no_argument,		NULL,		'u'},
	{0, 0, 0, 0}
};

#ifdef	HUMAN68K
#define	GETOPT_STRING	"1248AB:DFL:NO:SVbdfhltu"
#define	HELPOPT_STRING	"1248ADFNSVbdfhltu"
#else
#define	GETOPT_STRING	"1248AB:DFL:O:SVbdfhlu"
#define	HELPOPT_STRING	"1248ADFSVbdfhlu"
#endif

static void print_help(void)
{
	fprintf(stderr,
"usage: xd [" HELPOPT_STRING "] [-B=bias] [-L=length] [-O=offset] [files]\n"
#ifdef	JMSG
"       -1 --char           PoCg_v(default)\n"
"       -2 --short          QoCg_v\n"
"       -4 --long           SoCg_v\n"
"       -8 --longlong       WoCg_v\n"
"       -A --no-address     AhXo͗}\n"
"       -B --bias           _vAhX̃oCAXݒ\n"
"       -D --no-dump        _vo͗}\n"
"       -F --no-filename    t@Co͗}\n"
"       -L --length         _v̐ݒ\n"
#ifdef	HUMAN68K
"       -N --no-check-null  null foCX`FbN}\n"
#endif
"       -O --offset         _vItZbg̐ݒ\n"
"       -S --no-string      o͗}\n"
"       -V --version        o[W\\n"
"       -b --big-endian     MSB first ̃oCgȂюw\n"
"       -d --dump-decimal   t\io\n"
"       -f --dump-float     _o\n"
"       -h --help           ̃bZ[W̕\\n"
"       -l --little-endian  LSB first ̃oCgȂюw\n"
#if	defined(HUMAN68K) || defined(MSDOS)
"       -t --text-output     text [hŏo͂\n"
#endif
"       -u --dump-unsigned  \io\n"
#else
"       -1 --char           dump 1 byte(default)\n"
"       -2 --short          dump 2 bytes\n"
"       -4 --long           dump 4 bytes\n"
"       -8 --longlong       dump 8 bytes\n"
"       -A --no-address     dump with no address\n"
"       -B --bias           specify address bias\n"
"       -D --no-dump        dump with no value\n"
"       -F --no-filename    dump with no filename\n"
"       -L --length         specify dump length\n"
#ifdef	HUMAN68K
"       -N --no-check-null  no checking null device\n"
#endif
"       -O --offset         specify dump offset\n"
"       -S --no-string      dump with no string\n"
"       -V --version        display version\n"
"       -b --big-endian     MSB first byte order\n"
"       -d --dump-decimal   signed decimal format\n"
"       -f --dump-float     float format\n"
"       -h --help           display this message\n"
"       -l --little-endian  LSB first byte order\n"
#if	defined(HUMAN68K) || defined(MSDOS)
"       -T --text-output    always output text mode\n"
#endif
"       -u --dump-unsigned  unsigned decimal format\n"
#endif
	);
	exit(-1);
}


/* global variables */
int	endian;				/* big-endian:0, little-endian:1 */
int	string_length = 16;	/* Ps̏o͕ */
int overrun_ok = 0;
int overrun_yes = 0;
ul_t	address;

/* function scope variables */
static uc_t xdtab[] = "0123456789abcdef";
static uc_t* (*Fdump_adr)(uc_t* cset, uc_t* dst, ul_t* src);
static uc_t* (*Fdump_buf)(uc_t* cset, uc_t* dst, uc_t* src, int rest);
static uc_t* (*Fdump_str)(uc_t* dst, uc_t* src, int rest);

static uc_t	inpbuf[BUFSIZ+4];
static uc_t	outbuf[OUTBUFSIZ+256];
static uc_t*	outptr;
static uc_t*	outlimit;
static int		output_isatty;
#if	defined(HUMAN68K) || defined(MSDOS)
static int	mode_stdin;
static int	mode_stdout;
#endif

static unsigned char* Fdump_adr_dummy(uc_t* cset, uc_t* dst, ul_t* src)
{
	return dst;
}


static unsigned char* Fdump_buf_dummy(uc_t* cset, uc_t* dst, uc_t* src, int n)
{
	return dst;
}


static unsigned char* Fdump_str_dummy(unsigned char* dst, unsigned char* src, int rest)
{
	return dst;
}


static int	set_endian(void)
{
	endian = 1;
	return endian = (int)*(char*)&endian;
}


static size_t	get_buffer(FILE* fp)
{
	int	c;
	size_t	n, size;

	overrun_ok = 0;
	size = min(BUFSIZ, dump_length - dump_position);
	if ((n = fread(inpbuf, sizeof(uc_t), size, fp)) == size) {
		if ((c = fgetc(fp)) != EOF) {
			inpbuf[size] = c;
			ungetc(c, fp);
			overrun_ok = 1;
		}
	}
	dump_position += n;
	return n;
}


static int	xd(FILE* fp)
{
	size_t	n;
	uc_t*	dst;
	uc_t*	ptr;

	dump_position = 0UL;
	address = dump_offset - dump_bias;
	if (fseek(fp, dump_offset, SEEK_SET)) {
#ifdef	JMSG
		fputs("xd: fseek Ɏs܂\n", stderr);
#else
		fputs("xd: cannot fseek\n", stderr);
#endif
		return 0;
	}
	if (output_isatty) {
		while (n = get_buffer(fp)) {
			ptr = inpbuf;
			while ((int)n > 0) {
				dst = (*Fdump_adr)(xdtab, outbuf, &address);
				dst = (*Fdump_buf)(xdtab, dst, ptr, n);
				dst = (*Fdump_str)(dst, ptr, n);
				*dst++ = '\n';
				*dst = '\0';
				fputs(outbuf, stdout);
				n -= (size_t)string_length;
				ptr += string_length;
				address += (unsigned long)string_length;
			}
		}
	}
	else {
		while (n = get_buffer(fp)) {
			ptr = inpbuf;
			while ((int)n > 0) {
				outptr = (*Fdump_adr)(xdtab, outptr, &address);
				outptr = (*Fdump_buf)(xdtab, outptr, ptr, n);
				outptr = (*Fdump_str)(outptr, ptr, n);
				*outptr++ = '\n';
				if (outptr - outlimit >= 0) {
					write(fileno(stdout), outbuf, OUTBUFSIZ);
					if (outptr - outlimit > 0) memcpy(outbuf, outlimit, outptr - outlimit);
					outptr = outbuf + (outptr - outlimit);
				}
				n -= (size_t)string_length;
				ptr += string_length;
				address += (unsigned long)string_length;
			}
		}
	}
	if (dump_length == ULONG_MAX) {
		if (!feof(fp)) {
#ifdef	JMSG
			fputs("xd: Ō܂œǂݍ߂܂\n", stderr);
#else
			fputs("xd: not reach eof\n", stderr);
#endif
		}
	}
	return feof(stdout);
}


static void	check_outbuf(void)
{
	if (outptr >= outlimit) {
		write(fileno(stdout), outbuf, OUTBUFSIZ);
		if (outptr > outlimit) memcpy(outbuf, outlimit, outptr - outlimit);
		outptr = outbuf + (outptr - outlimit);
	}
}


static void	print_filename(char* name)
{
	int	i, length;

	length = _m_strlen(name);
	if (output_isatty) {
		for (i = length; --i >= 0; ) {
			putchar(':');
		}
		fputc('\n', stdout);
		puts(name);
		for (i = length; --i >= 0; ) {
			putchar(':');
		}
		fputc('\n', stdout);
	}
	else {
		outptr = memset(outptr, ':', length) + length;
		*outptr++ = '\n';
		check_outbuf();

		outptr = memcpy(outptr, name, length) + length;
		*outptr++ = '\n';
		check_outbuf();

		outptr = memset(outptr, ':', length) + length;
		*outptr++ = '\n';
		check_outbuf();
	}
}


static void	term_xd(void)
{
#if	defined(HUMAN68K) || defined(MSDOS)
	fmode(stdin,  mode_stdin);
	fmode(stdout, mode_stdout);
#endif
}


static void	init_xd(void)
{
	outlimit = (outptr = outbuf) + OUTBUFSIZ;
	Fdump_adr = (dump_order = set_endian()) ? l4toaddr : b4toaddr;
	Fdump_buf = c16toha;
	Fdump_str = dump_string;
#if	defined(HUMAN68K) || defined(MSDOS)
	mode_stdin  = stdin->_flag  & (_IOTEXT|_IOBINARY);
	mode_stdout = stdout->_flag & (_IOTEXT|_IOBINARY);
	onexit(term_xd);
#endif
}


int	main(int argc, char** argv)
{
#if	defined(HUMAN68K) || defined(MSDOS)
	int	dupfd;
#endif
	int	c, count;
	int	add_filename = 0;
	FILE*	fp;

	init_xd();

	optind = 0;

	while ((c = getopt_long(argc, argv, GETOPT_STRING, long_opt, &count)) != EOF) {
		switch (c) {
		case 0:
			*long_opt[count].flag = 1;
			break;
		case '1':
		case '2':
		case '4':
		case '8':
			dump_type = c - '0';
			break;
		case 'A':
			adr_out = 0;
			break;
		case 'B':
			if (sscanf(optarg, "%li", &dump_bias) != 1
			&&  sscanf(optarg, "=%li", &dump_bias) != 1) {
				fputs("xd: illegal bias\n", stderr);
			}
			break;
		case 'D':
			buf_out = 0;
			break;
		case 'F':
			fil_out = 0;
			break;
		case 'L':
			if (sscanf(optarg, "%li", &dump_length) != 1
			&&  sscanf(optarg, "=%li", &dump_length) != 1) {
				fputs("xd: illegal length\n", stderr);
			}
			break;
#ifdef	HUMAN68K
		case 'N':
			chk_nul = 0;
			break;
#endif
		case 'O':
			if (sscanf(optarg, "%li", &dump_offset) != 1
			&&  sscanf(optarg, "=%li", &dump_offset) != 1) {
				fputs("xd: illegal length\n", stderr);
			}
			break;
		case 'S':
			str_out = 0;
			break;
		case 'V':
			version = 1;
			break;
		case 'b':
			dump_order = XD_ORDER_BIG;
			break;
		case 'd':
			dump_format = XD_FORMAT_DECIMAL;
			break;
		case 'f':
			dump_format = XD_FORMAT_FLOAT;
			break;
		case 'h':
			help = 1;
			break;
		case 'l':
			dump_order = XD_ORDER_LITTLE;
			break;
#if	defined(HUMAN68K) || defined(MSDOS)
		case 't':
			out_bin = 0;
			break;
#endif
		case 'u':
			dump_format = XD_FORMAT_UNSIGNED;
			break;
		case '?':	/* unkown option */
		default:
			print_help();
			break;
		}
	}

	if (buf_out == 0 && str_out == 0) {
		return 0;
	}

	if (dump_format == XD_FORMAT_FLOAT && dump_type < XD_TYPE_LONG) {
#ifdef	JMSG
		fputs("xd: -f(--dump-float)  -4(--long) ȏ̃TCYw肵ĉ\n", stderr);
#else
		fputs("xd: option -f(--dump-float) nees over -4(--long) size\n", stderr);
#endif
		return 1;
	}

	if (version) {
		print_copyright();
		if (argc == 2 && strcmp(argv[1], "-V") == 0) return 0;
	}
	if (help || (argc == optind && isatty(fileno(stdin)) == 1)) print_help();
#ifdef	HUMAN68K
	if (chk_nul) {
		c = _dos_ioctrlgt(fileno(stdout));
		if ((c & 0x8000) && (c & 4) && (c & 3) == 0) {
			return 0;
		}
	}
#endif

	if (adr_out == 0) Fdump_adr = Fdump_adr_dummy;
	if (buf_out == 0) {
		Fdump_buf = Fdump_buf_dummy;
		string_length = 64;
	}
	else {
		switch (dump_type) {
		case XD_TYPE_UNDEF:
		case XD_TYPE_CHAR:
			switch (dump_format) {
			case XD_FORMAT_HEX:
				Fdump_buf = c16toha;
				break;
			case XD_FORMAT_DECIMAL:
				Fdump_buf = c16toda;
				break;
			case XD_FORMAT_UNSIGNED:
				Fdump_buf = c16toua;
				break;
			}
			break;
		case XD_TYPE_SHORT:
			switch (dump_format) {
			case XD_FORMAT_HEX:
				Fdump_buf = dump_order ? l2toha : b2toha;
				break;
			case XD_FORMAT_DECIMAL:
				Fdump_buf = dump_order ? l2toda : b2toda;
				break;
			case XD_FORMAT_UNSIGNED:
				Fdump_buf = dump_order ? l2toua : b2toua;
				break;
			}
			break;
		case XD_TYPE_LONG:
			switch (dump_format) {
			case XD_FORMAT_HEX:
				Fdump_buf = dump_order ? l4toha : b4toha;
				break;
			case XD_FORMAT_DECIMAL:
				Fdump_buf = dump_order ? l4toda : b4toda;
				break;
			case XD_FORMAT_UNSIGNED:
				Fdump_buf = dump_order ? l4toua : b4toua;
				break;
			case XD_FORMAT_FLOAT:
				Fdump_buf = dump_order ? l4tofa : b4tofa;
				break;
			}
			break;
		case XD_TYPE_LLONG:
			switch (dump_format) {
			case XD_FORMAT_HEX:
				Fdump_buf = dump_order ? l8toha : b8toha;
				break;
#ifdef	HAVE_LONGLONGINT
			case XD_FORMAT_DECIMAL:
				Fdump_buf = dump_order ? l8toda : b8toda;
				break;
			case XD_FORMAT_UNSIGNED:
				Fdump_buf = dump_order ? l8toua : b8toua;
				break;
#endif
			case XD_FORMAT_FLOAT:
				Fdump_buf = dump_order ? l8tofa : b8tofa;
				break;
			default:
#ifdef	JMSG
				fputs("xd: long long int ͎g܂\n", stderr);
#else
				fputs("xd: cannot use long long int\n", stderr);
#endif
				return 1;
			}
			break;
		}
	}
	if (str_out == 0) Fdump_str = Fdump_str_dummy;

#if	defined(HUMAN68K) || defined(MSDOS)
	if ((output_isatty = isatty(fileno(stdout))) == 0) {
		/* o͂̓_CNgĂ */
		if (out_bin) fmode(stdout, _IOBINARY);
	}
#else
	output_isatty = isatty(fileno(stdout));
#endif

	if (argc == optind) {
#if	defined(HUMAN68K) || defined(MSDOS)
		fmode(stdin, _IOBINARY);
		if ((dupfd = dup(fileno(stdin))) != -1) {
			close(fileno(stdin));
			fileno(stdin) = dupfd;
		}
#endif
		if (xd(stdin)) {
#ifdef	JMSG
			fputs("xd: o͂ł܂\n", stderr);
#else
			fputs("xd: cannot output\n", stderr);
#endif
			return -1;
		}
	}
	else {
		if (argc - optind >= 2 && fil_out) {
			add_filename = 1;
		}
		while (argc - optind > 0) {
			if (fp = fopen(argv[optind], "rb")) {
				if (add_filename) {
					print_filename(argv[optind]);
				}
				if (xd(fp)) {
#ifdef	JMSG
					fputs("xd: o͂ł܂\n", stderr);
#else
					fputs("xd: cannot output\n", stderr);
#endif
					return -1;
				}
				fclose(fp);
			}
			else {
#ifdef	JMSG
				fprintf(stderr, "xd: t@C %s I[vł܂\n", argv[optind]);
#else
				fprintf(stderr, "xd: cannnot open file %s\n", argv[optind]);
#endif
			}
			optind++;
		}
	}
	if (output_isatty == 0) {
		if (outptr - outbuf) write(fileno(stdout), outbuf, outptr - outbuf);
	}
	return 0;
}
