#ifndef	_XD_H_
/*
 *	xd.h: part of xd(heXadecimal Dump tool)
 *	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#define	_XD_H_	1

/*
 *	unsigned int short aliases
 */
typedef	unsigned long long	uL_t;
typedef	unsigned long		ul_t;
typedef	unsigned int		ui_t;
typedef	unsigned short		us_t;
typedef	unsigned char		uc_t;


#define	XD_TYPE_UNDEF	0
#define	XD_TYPE_CHAR	1	/* default */
#define	XD_TYPE_SHORT	2	/* 2bytes  */
#define	XD_TYPE_LONG	4	/* 4bytes  */
#define	XD_TYPE_LLONG	8	/* 8bytes  */

#define	XD_ORDER_BIG	0	/* big    endian */
#define	XD_ORDER_LITTLE	1	/* little endian */

#define	XD_FORMAT_HEX		0	/* 16i(default) */
#define	XD_FORMAT_DECIMAL	1	/* t10i */
#define	XD_FORMAT_UNSIGNED	2	/* Ȃ10i */
#define	XD_FORMAT_FLOAT		3	/* _ */

#define	BIG_ENDIAN		0
#define	LITTLE_ENDIAN	1

#ifndef	min
#define	min(a,b)	((a)<(b)?(a):(b))
#endif

/* global variables */
extern int	endian;
extern int	string_length;
extern int	overrun_ok;
extern int	overrun_yes;
extern ul_t	address;

extern uc_t*	b4toaddr(uc_t* cset, uc_t* buf, ul_t* ptr);
extern uc_t*	l4toaddr(uc_t* cset, uc_t* buf, ul_t* ptr);

extern uc_t*	c16toha(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	c16toda(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	c16toua(uc_t* cset, uc_t* buf, uc_t* ptr, int n);

extern uc_t*	b2toha(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	b4toha(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	b8toha(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l2toha(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l4toha(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l8toha(uc_t* cset, uc_t* buf, uc_t* ptr, int n);

extern uc_t*	b2toda(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	b4toda(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	b8toda(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l2toda(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l4toda(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l8toda(uc_t* cset, uc_t* buf, uc_t* ptr, int n);

extern uc_t*	b2toua(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	b4toua(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	b8toua(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l2toua(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l4toua(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l8toua(uc_t* cset, uc_t* buf, uc_t* ptr, int n);

extern uc_t*	b4tofa(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	b8tofa(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l4tofa(uc_t* cset, uc_t* buf, uc_t* ptr, int n);
extern uc_t*	l8tofa(uc_t* cset, uc_t* buf, uc_t* ptr, int n);

extern uc_t*	dump_string(uc_t* dst, uc_t* src, int rest);

#endif	_XD_H_
